diff --git a/src/libcharon/kernel/kernel_fc_sp.c b/src/libcharon/kernel/kernel_fc_sp.c
new file mode 100644
index 000000000..947684c0f
--- /dev/null
+++ b/src/libcharon/kernel/kernel_fc_sp.c
@@ -0,0 +1,61 @@
+/*
+ * Copyright (C) 2008 Tobias Brunner
+ * HSR Hochschule fuer Technik Rapperswil
+ * 
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation; either version 2 of the License, or (at your
+ * option) any later version.  See <http://www.fsf.org/copyleft/gpl.txt>.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
+ * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * for more details.
+ */
+
+/*
+ * Copyright (C) 2019-2022 Marvell 
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */
+ 
+#include "kernel_fc_sp.h"
+
+#include <daemon.h>
+
+/**
+ * See header
+ */
+bool kernel_fc_sp_register(plugin_t *plugin, plugin_feature_t *feature,
+						   bool reg, void *data)
+{
+	if (reg)
+	{
+		return charon->kernel->add_fc_sp_interface(charon->kernel,
+											(kernel_fc_sp_constructor_t)data);
+	}
+	else
+	{
+		return charon->kernel->remove_fc_sp_interface(charon->kernel,
+											(kernel_fc_sp_constructor_t)data);
+	}
+}
+
+
diff --git a/src/libcharon/kernel/kernel_fc_sp.h b/src/libcharon/kernel/kernel_fc_sp.h
new file mode 100644
index 000000000..9e1339432
--- /dev/null
+++ b/src/libcharon/kernel/kernel_fc_sp.h
@@ -0,0 +1,366 @@
+/*
+ * To change this license header, choose License Headers in Project Properties.
+ * To change this template file, choose Tools | Templates
+ * and open the template in the editor.
+ */
+
+/*
+ * Copyright (C) 2019-2022 Marvell 
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */
+ 
+/* 
+ * File:   kernel_fc_sp.h
+ * Author: cwinkler
+ *
+ * Created on October 20, 2020, 2:19 PM
+ */
+
+#ifndef KERNEL_FC_SP_H
+#define KERNEL_FC_SP_H
+
+typedef struct kernel_fc_sp_t kernel_fc_sp_t;
+typedef struct kernel_fc_sp_sa_id_t kernel_fc_sp_sa_id_t;
+typedef struct kernel_fc_sp_add_sa_t kernel_fc_sp_add_sa_t;
+typedef struct kernel_fc_sp_update_sa_t kernel_fc_sp_update_sa_t;
+typedef struct kernel_fc_sp_query_sa_t kernel_fc_sp_query_sa_t;
+typedef struct kernel_fc_sp_del_sa_t kernel_fc_sp_del_sa_t;
+typedef struct kernel_fc_sp_policy_id_t kernel_fc_sp_policy_id_t;
+typedef struct kernel_fc_sp_manage_policy_t kernel_fc_sp_manage_policy_t;
+typedef struct kernel_fc_sp_query_policy_t kernel_fc_sp_query_policy_t;
+
+#include <networking/host.h>
+#include <ipsec/ipsec_types.h>
+#include <selectors/traffic_selector.h>
+#include <selectors/sec_label.h>
+#include <plugins/plugin.h>
+#include <kernel/kernel_interface.h>
+
+/**
+ * Data required to identify an SA in the kernel
+ */
+struct kernel_fc_sp_sa_id_t {
+	/** Source address */
+	host_t *src;
+	/** Destination address */
+	host_t *dst;
+	/** SPI */
+	uint32_t spi;
+	/** Protocol (ESP/AH) */
+	uint8_t proto;
+	/** Optional mark */
+	mark_t mark;
+	/** Optional interface ID */
+	uint32_t if_id;
+};
+
+/**
+ * Data required to add an SA to the kernel
+ */
+struct kernel_fc_sp_add_sa_t {
+	/** Reqid */
+	uint32_t reqid;
+	/** Mode (tunnel, transport...) */
+	ipsec_mode_t mode;
+	/** List of source traffic selectors */
+	linked_list_t *src_ts;
+	/** List of destination traffic selectors */
+	linked_list_t *dst_ts;
+	/** Network interface restricting policy */
+	char *interface;
+	/** Lifetime configuration */
+	lifetime_cfg_t *lifetime;
+	/** Encryption algorithm */
+	uint16_t enc_alg;
+	/** Encryption key */
+	chunk_t enc_key;
+	/** Integrity protection algorithm */
+	uint16_t int_alg;
+	/** Integrity protection key */
+	chunk_t int_key;
+	/** Anti-replay window size */
+	uint32_t replay_window;
+	/** Traffic Flow Confidentiality padding */
+	uint32_t tfc;
+	/** IPComp transform */
+	uint16_t ipcomp;
+	/** CPI for IPComp */
+	uint16_t cpi;
+	/** TRUE to enable UDP encapsulation for NAT traversal */
+	bool encap;
+	/** no (disabled), yes (enabled), auto (enabled if supported) */
+	hw_offload_t hw_offload;
+	/** Mark the SA should apply to packets after processing */
+	mark_t mark;
+	/** Security label to match or apply */
+	sec_label_t *label;
+	/** TRUE to use Extended Sequence Numbers */
+	bool esn;
+	/** TRUE to copy the DF bit to the outer IPv4 header in tunnel mode */
+	bool copy_df;
+	/** TRUE to copy the ECN header field to/from the outer header */
+	bool copy_ecn;
+	/** Whether to copy the DSCP header field to/from the outer header */
+	dscp_copy_t copy_dscp;
+	/** TRUE if initiator of the exchange creating the SA */
+	bool initiator;
+	/** TRUE if this is an inbound SA */
+	bool inbound;
+	/** TRUE if an SPI has already been allocated for this SA */
+	bool update;
+};
+
+/**
+ * Data required to update the hosts of an SA in the kernel
+ */
+struct kernel_fc_sp_update_sa_t {
+	/** CPI in case IPComp is used */
+	uint16_t cpi;
+	/** New source address */
+	host_t *new_src;
+	/** New destination address */
+	host_t *new_dst;
+	/** TRUE if UDP encapsulation is currently enabled */
+	bool encap;
+	/** TRUE to enable UDP encapsulation */
+	bool new_encap;
+};
+
+/**
+ * Data required to query an SA in the kernel
+ */
+struct kernel_fc_sp_query_sa_t {
+	uint16_t cpi;
+};
+
+/**
+ * Data required to delete an SA in the kernel
+ */
+struct kernel_fc_sp_del_sa_t {
+	/** CPI in case IPComp is used */
+	uint16_t cpi;
+};
+
+/**
+ * Data identifying a policy in the kernel
+ */
+struct kernel_fc_sp_policy_id_t {
+	/** Direction of traffic */
+	policy_dir_t dir;
+	/** Source traffic selector */
+	traffic_selector_t *src_ts;
+	/** Destination traffic selector */
+	traffic_selector_t *dst_ts;
+	/** Optional mark */
+	mark_t mark;
+	/** Optional interface ID */
+	uint32_t if_id;
+	/** Network interface restricting policy */
+	char *interface;
+};
+
+/**
+ * Data required to add/delete a policy to/from the kernel
+ */
+struct kernel_fc_sp_manage_policy_t {
+	/** Type of policy */
+	policy_type_t type;
+	/** Priority class */
+	policy_priority_t prio;
+	/** Manually-set priority (automatic if set to 0) */
+	uint32_t manual_prio;
+	/** Source address of the SA(s) tied to this policy */
+	host_t *src;
+	/** Destination address of the SA(s) tied to this policy */
+	host_t *dst;
+	/** Details about the SA(s) tied to this policy */
+	ipsec_sa_cfg_t *sa;
+};
+
+/**
+ * Data required to query a policy in the kernel
+ */
+struct kernel_fc_sp_query_policy_t {
+};
+
+
+/**
+ * Interface to the fc-sp subsystem.
+ *
+ * The kernel fc-sp interface handles the communication with the FC-SP 
+ * module that will communicate to the lower level that handles the SAs.
+ * FC-SP does not currently use policies so they are not provided in this
+ * implementation of the interface.
+ */
+struct kernel_fc_sp_t {
+
+	/**
+	 * Get the feature set supported by this kernel backend.
+	 *
+	 * @return				ORed feature-set of backend
+	 */
+	kernel_feature_t (*get_features)(kernel_fc_sp_t *this);
+
+	/**
+	 * Get a SPI from the kernel.
+	 *
+	 * @param src		source address of SA
+	 * @param dst		destination address of SA
+	 * @param protocol	protocol for SA (ESP/AH)
+	 * @param spi		allocated spi
+	 * @return			SUCCESS if operation completed
+	 */
+	status_t (*get_spi)(kernel_fc_sp_t *this, host_t *src, host_t *dst,
+						uint8_t protocol, uint32_t *spi);
+        
+        /**
+	 * Get a Compression Parameter Index (CPI) from the kernel.
+	 *
+	 * @param src		source address of SA
+	 * @param dst		destination address of SA
+	 * @param cpi		allocated cpi
+	 * @return			SUCCESS if operation completed
+	 */
+	status_t (*get_cpi)(kernel_fc_sp_t *this, host_t *src, host_t *dst,
+						uint16_t *cpi);
+
+	/**
+	 * Add an SA to the SAD.
+	 *
+	 * This function does install a single SA for a single protocol in one
+	 * direction.
+	 *
+	 * @param id			data identifying this SA
+	 * @param data			data for this SA
+	 * @return				SUCCESS if operation completed
+	 */
+	status_t (*add_sa)(kernel_fc_sp_t *this, kernel_fc_sp_sa_id_t *id,
+					   kernel_fc_sp_add_sa_t *data);
+        
+        /**
+	 * Update the hosts on an installed SA.
+	 *
+	 * We cannot directly update the destination address as the kernel
+	 * requires the spi, the protocol AND the destination address (and family)
+	 * to identify SAs. Therefore if the destination address changed we
+	 * create a new SA and delete the old one.
+	 *
+	 * @param id			data identifying this SA
+	 * @param data			updated data for this SA
+	 * @return				SUCCESS if operation completed, NOT_SUPPORTED if
+	 *						the kernel interface can't update the SA
+	 */
+	status_t (*update_sa)(kernel_fc_sp_t *this, kernel_fc_sp_sa_id_t *id,
+						  kernel_fc_sp_update_sa_t *data);
+
+	/**
+	 * Query the number of bytes processed by an SA from the SAD.
+	 *
+	 * @param id			data identifying this SA
+	 * @param data			data to query the SA
+	 * @param[out] bytes	the number of bytes processed by SA
+	 * @param[out] packets	number of packets processed by SA
+	 * @param[out] time		last (monotonic) time of SA use
+	 * @return				SUCCESS if operation completed
+	 */
+	status_t (*query_sa)(kernel_fc_sp_t *this, kernel_fc_sp_sa_id_t *id,
+						 kernel_fc_sp_query_sa_t *data, uint64_t *bytes,
+						 uint64_t *packets, time_t *time);
+
+	/**
+	 * Delete a previously installed SA from the SAD.
+	 *
+	 * @param id			data identifying this SA
+	 * @param data			data to delete the SA
+	 * @return				SUCCESS if operation completed
+	 */
+	status_t (*del_sa)(kernel_fc_sp_t *this, kernel_fc_sp_sa_id_t *id,
+					   kernel_fc_sp_del_sa_t *data);
+        
+        /**
+	 * Add a policy to the SPD.
+	 *
+	 * @param id			data identifying this policy
+	 * @param data			data for this policy
+	 * @return				SUCCESS if operation completed
+	 */
+	status_t (*add_policy)(kernel_fc_sp_t *this,
+						   kernel_fc_sp_policy_id_t *id,
+						   kernel_fc_sp_manage_policy_t *data);
+
+	/**
+	 * Query the use time of a policy.
+	 *
+	 * The use time of a policy is the time the policy was used for the last
+	 * time. It is not the system time, but a monotonic timestamp as returned
+	 * by time_monotonic.
+	 *
+	 * @param id			data identifying this policy
+	 * @param data			data to query the policy
+	 * @param[out] use_time	the monotonic timestamp of this SA's last use
+	 * @return				SUCCESS if operation completed
+	 */
+	status_t (*query_policy)(kernel_fc_sp_t *this,
+							 kernel_fc_sp_policy_id_t *id,
+							 kernel_fc_sp_query_policy_t *data,
+							 time_t *use_time);
+
+	/**
+	 * Remove a policy from the SPD.
+	 *
+	 * @param id			data identifying this policy
+	 * @param data			data for this policy
+	 * @return				SUCCESS if operation completed
+	 */
+	status_t (*del_policy)(kernel_fc_sp_t *this,
+						   kernel_fc_sp_policy_id_t *id,
+						   kernel_fc_sp_manage_policy_t *data);
+
+	/**
+	 * Install a bypass policy for the given socket.
+	 *
+	 * @param fd			socket file descriptor to setup policy for
+	 * @param family		protocol family of the socket
+	 * @return				TRUE of policy set up successfully
+	 */
+	bool (*bypass_socket)(kernel_fc_sp_t *this, int fd, int family);
+
+	/**
+	 * Enable decapsulation of ESP-in-UDP packets for the given port/socket.
+	 *
+	 * @param fd			socket file descriptor
+	 * @param family		protocol family of the socket
+	 * @param port			the UDP port
+	 * @return				TRUE if UDP decapsulation was enabled successfully
+	 */
+	bool (*enable_udp_decap)(kernel_fc_sp_t *this, int fd, int family,
+							 uint16_t port);
+
+	/**
+	 * Destroy the implementation.
+	 */
+	void (*destroy)(kernel_fc_sp_t *this);
+};
+
+bool kernel_fc_sp_register(plugin_t *plugin, plugin_feature_t *feature,
+						   bool reg, void *data);
+
+#endif /* KERNEL_FC_SP_H */
+
diff --git a/src/libcharon/kernel/kernel_interface.c b/src/libcharon/kernel/kernel_interface.c
index 4f4a99731..e54f2acd8 100644
--- a/src/libcharon/kernel/kernel_interface.c
+++ b/src/libcharon/kernel/kernel_interface.c
@@ -37,6 +37,28 @@
  * THE SOFTWARE.
  */
 
+/*
+ * Copyright (C) 2019-2022 Marvell 
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */
+
 #include "kernel_interface.h"
 
 #include <utils/debug.h>
@@ -90,6 +112,11 @@ struct private_kernel_interface_t {
 	 */
 	kernel_ipsec_constructor_t ipsec_constructor;
 
+	/**
+	 * Registered FC-SP constructor
+	 */
+	kernel_fc_sp_constructor_t fc_sp_constructor;
+
 	/**
 	 * Registered net constructor
 	 */
@@ -100,6 +127,11 @@ struct private_kernel_interface_t {
 	 */
 	kernel_ipsec_t *ipsec;
 
+	/**
+	 * fc-sp interface
+	 */
+	kernel_fc_sp_t *fc_sp;
+
 	/**
 	 * network interface
 	 */
@@ -154,17 +186,27 @@ struct private_kernel_interface_t {
 };
 
 METHOD(kernel_interface_t, get_features, kernel_feature_t,
-	private_kernel_interface_t *this)
+	private_kernel_interface_t *this, int family)
 {
 	kernel_feature_t features = 0;
 
-	if (this->ipsec && this->ipsec->get_features)
+	if (family == AF_NETLINK)
 	{
-		features |= this->ipsec->get_features(this->ipsec);
+		if (this->fc_sp && this->fc_sp->get_features)
+		{
+			features |= this->fc_sp->get_features(this->fc_sp);
+		}
 	}
-	if (this->net && this->net->get_features)
+	else
 	{
-		features |= this->net->get_features(this->net);
+      	if (this->ipsec && this->ipsec->get_features)
+      	{
+      		features |= this->ipsec->get_features(this->ipsec);
+      	}
+      	if (this->net && this->net->get_features)
+      	{
+      		features |= this->net->get_features(this->net);
+      	}
 	}
 	return features;
 }
@@ -173,6 +215,19 @@ METHOD(kernel_interface_t, get_spi, status_t,
 	private_kernel_interface_t *this, host_t *src, host_t *dst,
 	uint8_t protocol, uint32_t *spi)
 {
+	
+	int family = src->get_family (src);
+	
+	if (family == AF_NETLINK)
+	{
+		if (!this->fc_sp)
+		{
+			return NOT_SUPPORTED;
+		}
+		
+		return this->fc_sp->get_spi (this->fc_sp, src, dst, protocol, spi);
+	}
+	
 	if (!this->ipsec)
 	{
 		return NOT_SUPPORTED;
@@ -184,6 +239,17 @@ METHOD(kernel_interface_t, get_cpi, status_t,
 	private_kernel_interface_t *this, host_t *src, host_t *dst,
 	uint16_t *cpi)
 {
+	int family = src->get_family (src);
+	
+	if (family == AF_NETLINK)
+	{
+		if (!this->fc_sp)
+		{
+			return NOT_SUPPORTED;
+		}
+		this->fc_sp->get_cpi (this->fc_sp, src, dst, cpi);
+	}
+	
 	if (!this->ipsec)
 	{
 		return NOT_SUPPORTED;
@@ -474,6 +540,18 @@ METHOD(kernel_interface_t, add_sa, status_t,
 	private_kernel_interface_t *this, kernel_ipsec_sa_id_t *id,
 	kernel_ipsec_add_sa_t *data)
 {
+	int family = id->src->get_family (id->src);
+	
+	if (family == AF_NETLINK)
+	{
+		if (!this->fc_sp)
+		{
+			return NOT_SUPPORTED;
+		}
+		
+		return this->fc_sp->add_sa (this->fc_sp, (kernel_fc_sp_sa_id_t*) id, (kernel_fc_sp_add_sa_t*) data);
+	}
+	
 	if (!this->ipsec)
 	{
 		return NOT_SUPPORTED;
@@ -497,6 +575,18 @@ METHOD(kernel_interface_t, query_sa, status_t,
 	kernel_ipsec_query_sa_t *data, uint64_t *bytes, uint64_t *packets,
 	time_t *time)
 {
+	int family = id->src->get_family (id->src);
+	
+	if (family == AF_NETLINK)
+	{
+		if (!this->fc_sp)
+		{
+			return NOT_SUPPORTED;
+		}
+		
+		return this->fc_sp->query_sa (this->fc_sp, (kernel_fc_sp_sa_id_t*) id, (kernel_fc_sp_query_sa_t*) data, bytes, packets, time);
+	}
+	
 	if (!this->ipsec)
 	{
 		return NOT_SUPPORTED;
@@ -508,6 +598,18 @@ METHOD(kernel_interface_t, del_sa, status_t,
 	private_kernel_interface_t *this, kernel_ipsec_sa_id_t *id,
 	kernel_ipsec_del_sa_t *data)
 {
+	int family = id->src->get_family (id->src);
+	
+	if (family == AF_NETLINK)
+	{
+		if (!this->fc_sp)
+		{
+			return NOT_SUPPORTED;
+		}
+		
+		return this->fc_sp->del_sa (this->fc_sp, (kernel_fc_sp_sa_id_t*) id, (kernel_fc_sp_del_sa_t*) data);
+	}
+	
 	if (!this->ipsec)
 	{
 		return NOT_SUPPORTED;
@@ -529,6 +631,17 @@ METHOD(kernel_interface_t, add_policy, status_t,
 	private_kernel_interface_t *this, kernel_ipsec_policy_id_t *id,
 	kernel_ipsec_manage_policy_t *data)
 {
+	int family = data->src->get_family (data->src);
+	
+	if (family == AF_NETLINK)
+	{
+		if (!this->fc_sp)
+		{
+			return NOT_SUPPORTED;
+		}
+		return this->fc_sp->add_policy(this->fc_sp, (kernel_fc_sp_policy_id_t*) id, (kernel_fc_sp_manage_policy_t*) data);
+	}
+	
 	if (!this->ipsec)
 	{
 		return NOT_SUPPORTED;
@@ -540,6 +653,14 @@ METHOD(kernel_interface_t, query_policy, status_t,
 	private_kernel_interface_t *this, kernel_ipsec_policy_id_t *id,
 	kernel_ipsec_query_policy_t *data, time_t *use_time)
 {
+	if (data->family == AF_NETLINK)
+	{
+		if (!this->fc_sp)
+		{
+			return NOT_SUPPORTED;
+		}
+		return this->fc_sp->query_policy(this->fc_sp, (kernel_fc_sp_policy_id_t*) id, (kernel_fc_sp_query_policy_t*) data, use_time);
+	}
 	if (!this->ipsec)
 	{
 		return NOT_SUPPORTED;
@@ -551,6 +672,17 @@ METHOD(kernel_interface_t, del_policy, status_t,
 	private_kernel_interface_t *this, kernel_ipsec_policy_id_t *id,
 	kernel_ipsec_manage_policy_t *data)
 {
+	int family = data->src->get_family (data->src);
+	
+	if (family == AF_NETLINK)
+	{
+		if (!this->fc_sp)
+		{
+			return NOT_SUPPORTED;
+		}
+		return this->fc_sp->del_policy (this->fc_sp, (kernel_fc_sp_policy_id_t*) id, (kernel_fc_sp_manage_policy_t*) data);
+	}
+	
 	if (!this->ipsec)
 	{
 		return NOT_SUPPORTED;
@@ -669,6 +801,15 @@ METHOD(kernel_interface_t, del_route, status_t,
 METHOD(kernel_interface_t, bypass_socket, bool,
 	private_kernel_interface_t *this, int fd, int family)
 {
+	if (family == AF_NETLINK)
+	{
+		if (!this->fc_sp)
+		{
+			return NOT_SUPPORTED;
+		}
+		return this->fc_sp->bypass_socket(this->fc_sp, fd, family);
+	}
+	
 	if (!this->ipsec)
 	{
 		return FALSE;
@@ -679,6 +820,15 @@ METHOD(kernel_interface_t, bypass_socket, bool,
 METHOD(kernel_interface_t, enable_udp_decap, bool,
 	private_kernel_interface_t *this, int fd, int family, uint16_t port)
 {
+	if (family == AF_NETLINK)
+	{
+		if (!this->fc_sp)
+		{
+			return NOT_SUPPORTED;
+		}
+		return this->fc_sp->enable_udp_decap(this->fc_sp, fd, family, port);
+	}
+	
 	if (!this->ipsec)
 	{
 		return FALSE;
@@ -813,6 +963,31 @@ METHOD(kernel_interface_t, remove_ipsec_interface, bool,
 	return FALSE;
 }
 
+
+METHOD(kernel_interface_t, add_fc_sp_interface, bool,
+	private_kernel_interface_t *this, kernel_fc_sp_constructor_t constructor)
+{
+	if (!this->fc_sp)
+	{
+		this->fc_sp_constructor = constructor;
+		this->fc_sp = constructor();
+		return this->fc_sp != NULL;
+	}
+	return FALSE;
+}
+
+METHOD(kernel_interface_t, remove_fc_sp_interface, bool,
+	private_kernel_interface_t *this, kernel_fc_sp_constructor_t constructor)
+{
+	if (constructor == this->fc_sp_constructor && this->fc_sp)
+	{
+		this->fc_sp->destroy(this->fc_sp);
+		this->fc_sp = NULL;
+		return TRUE;
+	}
+	return FALSE;
+}
+
 METHOD(kernel_interface_t, add_net_interface, bool,
 	private_kernel_interface_t *this, kernel_net_constructor_t constructor)
 {
@@ -1031,6 +1206,7 @@ METHOD(kernel_interface_t, destroy, void,
 	this->algorithms->destroy(this->algorithms);
 	this->mutex_algs->destroy(this->mutex_algs);
 	DESTROY_IF(this->ipsec);
+	DESTROY_IF(this->fc_sp);
 	DESTROY_IF(this->net);
 	DESTROY_FUNCTION_IF(this->ifaces_filter, (void*)free);
 	this->reqids->destroy(this->reqids);
@@ -1082,6 +1258,8 @@ kernel_interface_t *kernel_interface_create()
 			.get_address_by_ts = _get_address_by_ts,
 			.add_ipsec_interface = _add_ipsec_interface,
 			.remove_ipsec_interface = _remove_ipsec_interface,
+			.add_fc_sp_interface = _add_fc_sp_interface,
+			.remove_fc_sp_interface = _remove_fc_sp_interface,
 			.add_net_interface = _add_net_interface,
 			.remove_net_interface = _remove_net_interface,
 
diff --git a/src/libcharon/kernel/kernel_interface.h b/src/libcharon/kernel/kernel_interface.h
index 21b777ae9..c85d8df9f 100644
--- a/src/libcharon/kernel/kernel_interface.h
+++ b/src/libcharon/kernel/kernel_interface.h
@@ -39,6 +39,28 @@
  * THE SOFTWARE.
  */
 
+/*
+ * Copyright (C) 2019-2022 Marvell 
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */
+
 /**
  * @defgroup kernel_interface kernel_interface
  * @{ @ingroup kernel
@@ -55,6 +77,7 @@ typedef enum kernel_feature_t kernel_feature_t;
 #include <kernel/kernel_listener.h>
 #include <kernel/kernel_ipsec.h>
 #include <kernel/kernel_net.h>
+#include <kernel/kernel_fc_sp.h>
 
 /**
  * Default range for SPIs requested from kernels
@@ -86,6 +109,11 @@ enum kernel_feature_t {
  */
 typedef kernel_ipsec_t* (*kernel_ipsec_constructor_t)(void);
 
+/**
+ * Constructor function for fc-sp kernel interface
+ */
+typedef kernel_fc_sp_t* (*kernel_fc_sp_constructor_t)(void);
+
 /**
  * Constructor function for network kernel interface
  */
@@ -104,7 +132,7 @@ struct kernel_interface_t {
 	 *
 	 * @return				ORed feature-set of backends
 	 */
-	kernel_feature_t (*get_features)(kernel_interface_t *this);
+	kernel_feature_t (*get_features)(kernel_interface_t *this, int family);
 
 	/**
 	 * Get a SPI from the kernel.
@@ -476,6 +504,26 @@ struct kernel_interface_t {
 	bool (*remove_ipsec_interface)(kernel_interface_t *this,
 								   kernel_ipsec_constructor_t create);
 
+	/**
+	 * Register an fc-sp interface constructor on the manager.
+	 *
+	 * @param create		constructor to register
+	 * @return				TRUE if the fc-sp kernel interface was registered
+	 *						successfully, FALSE if an interface was already
+	 *						registered or the registration failed
+	 */
+        bool (*add_fc_sp_interface) (kernel_interface_t *this, kernel_fc_sp_constructor_t constructor);
+        
+        /**
+	 * Unregister an fc-sp interface constructor.
+	 *
+	 * @param create		constructor to unregister
+	 * @return				TRUE if the ipsec kernel interface was unregistered
+	 *						successfully, FALSE otherwise
+	 */
+	bool (*remove_fc_sp_interface)(kernel_interface_t *this,
+								   kernel_fc_sp_constructor_t create);
+
 	/**
 	 * Register a network kernel interface constructor on the manager.
 	 *
diff --git a/src/libcharon/kernel/kernel_ipsec.h b/src/libcharon/kernel/kernel_ipsec.h
index ae8b82a40..968d8b868 100644
--- a/src/libcharon/kernel/kernel_ipsec.h
+++ b/src/libcharon/kernel/kernel_ipsec.h
@@ -18,6 +18,28 @@
  * for more details.
  */
 
+/*
+ * Copyright (C) 2019-2022 Marvell 
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */
+
 /**
  * @defgroup kernel_ipsec kernel_ipsec
  * @{ @ingroup kernel
@@ -192,6 +214,7 @@ struct kernel_ipsec_manage_policy_t {
  * Data required to query a policy in the kernel
  */
 struct kernel_ipsec_query_policy_t {
+    int family;
 };
 
 /**
diff --git a/src/libcharon/network/sender.c b/src/libcharon/network/sender.c
index 4543766d6..d1745059c 100644
--- a/src/libcharon/network/sender.c
+++ b/src/libcharon/network/sender.c
@@ -16,6 +16,28 @@
  * for more details.
  */
 
+/*
+ * Copyright (C) 2019-2022 Marvell 
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */
+
 #include <unistd.h>
 #include <stdlib.h>
 
@@ -50,6 +72,10 @@ struct private_sender_t {
 	 */
 	mutex_t *mutex;
 
+	mutex_t *wakeup_mutex;
+	
+	int	sender_thread_count;
+
 	/**
 	 * condvar to signal for packets added to list
 	 */
@@ -98,8 +124,8 @@ METHOD(sender_t, send_, void,
 	src = packet->get_source(packet);
 	dst = packet->get_destination(packet);
 
-	DBG1(DBG_NET, "sending packet: from %#H to %#H (%zu bytes)", src, dst,
-		 packet->get_data(packet).len);
+	DBG1(DBG_NET, "sending packet: from %#H to %#H (%zu bytes), src family: %d", src, dst,
+		 packet->get_data(packet).len, src->get_family (src));
 
 	if (this->send_delay)
 	{
@@ -142,6 +168,7 @@ static job_requeue_t send_packets(private_sender_t *this)
 {
 	packet_t *packet;
 	bool oldstate;
+	bool got_wakeup_mutex = false;
 
 	this->mutex->lock(this->mutex);
 	while (this->list->get_count(this->list) == 0)
@@ -151,12 +178,27 @@ static job_requeue_t send_packets(private_sender_t *this)
 		oldstate = thread_cancelability(TRUE);
 
 		this->got->wait(this->got, this->mutex);
+		this->wakeup_mutex->lock (this->wakeup_mutex);
+		got_wakeup_mutex = true;
 
 		thread_cancelability(oldstate);
 		thread_cleanup_pop(FALSE);
+		
+		// If there is a spurious wakeup and we are the second ones to be awoken,
+		// there may be no send to service.  So double check after we get the wakeup lock
+		// that there is still something to be serviced
+		if (this->list->get_count(this->list) == 0)
+		{
+			this->wakeup_mutex->unlock (this->wakeup_mutex);
+			got_wakeup_mutex = false;
+		}
 	}
 	this->list->remove_first(this->list, (void**)&packet);
 	this->sent->signal(this->sent);
+	if (got_wakeup_mutex)
+	{
+		this->wakeup_mutex->unlock (this->wakeup_mutex);
+	}
 	this->mutex->unlock(this->mutex);
 
 	charon->socket->send(charon->socket, packet);
@@ -192,6 +234,7 @@ METHOD(sender_t, destroy, void,
 sender_t * sender_create()
 {
 	private_sender_t *this;
+	int i;
 
 	INIT(this,
 		.public = {
@@ -202,6 +245,9 @@ sender_t * sender_create()
 		},
 		.list = linked_list_create(),
 		.mutex = mutex_create(MUTEX_TYPE_DEFAULT),
+		.wakeup_mutex = mutex_create(MUTEX_TYPE_DEFAULT),
+		.sender_thread_count = lib->settings->get_int(lib->settings,
+									"%s.sender_thread_count", 1, lib->ns),
 		.got = condvar_create(CONDVAR_TYPE_DEFAULT),
 		.sent = condvar_create(CONDVAR_TYPE_DEFAULT),
 		.send_delay = lib->settings->get_int(lib->settings,
@@ -214,9 +260,12 @@ sender_t * sender_create()
 									"%s.send_delay_response", TRUE, lib->ns),
 	);
 
+	for (i = 0; i < this->sender_thread_count; i++)
+	{
 	lib->processor->queue_job(lib->processor,
 		(job_t*)callback_job_create_with_prio((callback_job_cb_t)send_packets,
 			this, NULL, (callback_job_cancel_t)return_false, JOB_PRIO_CRITICAL));
+	}
 
 	return &this->public;
 }
